<!DOCTYPE html>
<HTML>
<!--

FastPACS

2006-2013 Precision Diagnostic Systems, Inc.
Maple Park, IL 60151 USA



-->

<%@ Import Namespace="System.Xml" %>
<%@ Import Namespace="System.Globalization" %>
<%@ Import Namespace="DIOWave" %>
<%@ Import Namespace="System.IO" %>
<script src="classes.cs" runat="server" />
<script src="viewer-common.cs" runat="server" />
<script src="viewer-custom.cs" runat="server" />
<script src="viewer-xp.cs" runat="server" />
<%
//========================================================================================

	setup(Request);
	Writer = Response.Output;

	// Do not store viewer preferences
	//QueryStringValue QSV = new QueryStringValue(Request, m_browser, (StringDictionary)Session["viewerpref"]);
	QueryStringValue QSV = new QueryStringValue(Request, m_browser, new StringDictionary());
	if (QSV.bad) {
		Response.Clear();
		Server.Transfer("/DIOWave/blank1.htm");
	}
	XmlDocument config_dom = (XmlDocument)Application.Get("DIOWaveConf");
	DicomStudy DOM = loadDOM(QSV, config_dom);

	ImageSpaceObject ImageSpace = new ImageSpaceObject();
	ArrayList ImageList = new ArrayList();
	foreach (SOPInstanceObject file in DOM.fl)
		ImageList.Add(new ImageObject(file, ImageSpace));

	LayoutObject Layout = new LayoutObject(QSV, DOM);
	VOITableObject VOITable = new VOITableObject(ImageSpace, DOM, QSV, VOIPresets(DOM));
//========================================================================================
%>
<HEAD>
<TITLE>Series Viewer</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html;" charset="utf-8">
<link rel="stylesheet" type="text/css" href="media/css/jquery.jscrollpane.css">
    <link rel="stylesheet" type="text/css" href="media/css/reset.css">
    <link rel="stylesheet" type="text/css" href="media/css/chosen.css">
    <link rel="stylesheet" type="text/css" href="media/css/base.css">
    <script type="text/javascript" src="media/js/jquery-1.7.1.min.js"></script>
    <script type="text/javascript" src="media/js/jquery.mousewheel.js"></script>
    <script type="text/javascript" src="media/js/jquery.jscrollpane.js"></script>
    <script type="text/javascript" src="media/js/chosen.jquery.js"></script>
    <script type="text/javascript" src="media/js/jquery-ui.js"></script>

    <script type="text/javascript" id="sourcecode">
        $(function()
        {
			$(".chzn-select").css("display","");
            if (!($.browser.msie && parseInt($.browser.version, 10) <= 7)) {
                $(".chzn-select").chosen({
                    disable_search_threshold: 8,
                    drop_down_width: true,
                    inherit_select_classes: true,
					disable_search: true
                }).change(function(){ if(typeof api  != 'undefined') api.reinitialise();});

			    $('.chzn-search').hide();
            }

            if(! /Android|webOS|iPhone|iPod|BlackBerry/i.test(navigator.userAgent))
                $(".chzn-container, .chzn-select").hover(function () { $(this).mousedown().mouseup() }, function () { $('body').click() });

			onFirstLoad();

            var refreshIntervalId = false;
            var height = $(window).height()-109;

            $(".sidebar .items").css("height",height+"px");
            $('.scroll-pane').jScrollPane({
                showArrows: false,
                autoReinitialise: true,
                verticalDragMinHeight: 28,
                verticalDragMaxHeight: 28
            });
			var resizeTimeout;
            $(window).resize(function() {
                var height = $(window).height()-109;
                var wh = $(window).height();
                $(".sidebar .items").css("height",height+"px");

				if (resizeTimeout)
					clearTimeout(resizeTimeout);
				resizeTimeout = setTimeout(function(){
					Reload();
				}, 500);
            });
            $( "#slider-vertical" ).slider({
                orientation: "vertical",
                range: "min",
                min: 0,
                max: 100,
                value: 0,
                slide: function( event, ui ) {
                    //ui.value
                }
            });


            $(".control-bar").css('width',$(".x-ray").width()+"px");


            $(".arrow.down").mousedown(function(){
                refreshIntervalId = setInterval(SlideDown, 1);
            }).mouseup(function(){
                clearInterval(refreshIntervalId);
            });

            $(".arrow.top").mousedown(function(){
                refreshIntervalId = setInterval(SlideUp, 1);
            }).mouseup(function(){
                clearInterval(refreshIntervalId);
            });

			$('#overlay').change(function(){
				var v = $(this).find('option:selected').val();
				change_overlay(v);
			});

			$('#action').change(function(){
				var v = $(this).find('option:selected').val();
				/*if (v == '.')	$("#action-label").hide();
				else $("#action-label").show();*/
				change_action(v);
			});

			$('#range').change(function(){
				var v = $(this).find('option:selected').val();
				preset_voi(v);
			});

			$('#scale').change(function(){
				var v = $(this).find('option:selected').val();
				scale_changed(v);
			});

			$('#client').change(function(){
				var v = $(this).find('option:selected').val();
				client_ip(v);
			});

			//$("#overlay_chzn, #range_chzn, #action_chzn, #scale_chzn").find('.result-selected').hide().remove();
        });

        function SlideDown() {
            var selection = $( "#slider-vertical" ).slider( "value" ) - 1;
            $( "#slider-vertical" ).slider( "value", selection );
        }
        function SlideUp() {
            var selection = $( "#slider-vertical" ).slider( "value" ) + 1;
            $( "#slider-vertical" ).slider( "value", selection );
        }

    </script>
<SCRIPT LANGUAGE="JavaScript1.2">
//----------------------------------------------------------------------------------------
// Viewer independed code
//----------------------------------------------------------------------------------------
//------------------------------
//
//------------------------------
function prettyTime(time) {
	var str = new String(time);
	return str.substr(0, 2) + ':' + str.substr(2, 2) + ':' + str.substr(4, 4);
}

//------------------------------
// Image Object
//------------------------------
function IR(file, imageNumber, imageDate, imageTime, rows, cols, xs, ys, x, y, z, xd, yd, wc, ww) {
	this.file = file;
	this.number = imageNumber;
	this.date = imageDate;
	this.time = imageTime;
	this.rows = rows;
	this.cols = cols;
	this.xs = xs;
	this.ys = ys;
	this.x = x;
	this.y = y;
	this.z = z;
	this.xd = xd;
	this.yd = yd;
	this.wc = wc;
	this.ww = ww;
}

//------------------------------
//
//------------------------------
IR.prototype.uri = function() {
	return '/DIOWave/scripts/dio-image.dll'
	     + '<%=config_dom.SelectSingleNode("/DIOWaveConfiguration/VOLUME[@label=\"" + QSV.volume + "\"]/location").InnerText%>'
	     + '/'
	     + '<%=QSV.path%>'
	     + '/'
	     + this.file;
}

//------------------------------
// ImageBox
//------------------------------
function ImageBox(img, index) {
	this.img = img;
	this.index = index;
	this.loaded = true;
}
//------------------------------
//
//------------------------------
ImageBox.prototype.reload = function() {
	this.img.src = IDS.image_src(this.index, false);
}

//------------------------------
//
//------------------------------
ImageBox.prototype.start_track_update = function() {
	this.img.onload = onImageLoad;
	this.loaded = true;
}

//------------------------------
//
//------------------------------
ImageBox.prototype.track_update = function(nocache) {
	if (this.loaded) {
		this.loaded = false;
		this.img.src = IDS.image_src(this.index, nocache);
	}
}

//------------------------------
//
//------------------------------
ImageBox.prototype.end_track_update = function() {
	this.img.onload = null;
}

//------------------------------
//
//------------------------------
ImageBox.prototype.set_annotation = function() {
	set_annotation1(IDS.overlay, this.index);
}

//------------------------------
//
//------------------------------
function onActionMouseDown(e, action) {
	// close all chosen selects
	if (jQuery(".chzn-container-active").length > 0) {
		$("body").click();
		return true;
	}

	e = e.originalEvent || e || window.event;

	if (e.altKey || e.ctrlKey || e.shiftKey || e.metaKey)
		return true;

	CurrentAction = action;
	CurrentAction.mousedown(e);
	CurrentAction.begin_drag(e);

	$(document).bind('mousemove', onDocumentMouseMove)
			   .bind('mouseup', onDocumentMouseUp)
			   .bind('touchmove', onDocumentMouseMove)
			   .bind('touchend', onDocumentMouseUp);

	return false;
}

//------------------------------
//
//------------------------------
function onDocumentMouseUp(e) {
	if (e.originalEvent) e=e.originalEvent;
	if (CurrentAction != null) {
		CurrentAction.end_drag(e);
		CurrentAction = null;
	}

	$(document).unbind('mousemove')
			   .unbind('mouseup')
			   .unbind('touchmove')
			   .unbind('touchend');

	return false;
}

//------------------------------
//
//------------------------------
function onDocumentMouseMove(e) {
	if (e.originalEvent) e=e.originalEvent;
	if (CurrentAction != null)
		CurrentAction.do_drag(e);

	return false;
}

//------------------------------
// ImageActionObject
//------------------------------
function ImageActionObject() {
	this.md_imageX = -1;
	this.md_imageY = -1;
	this.md_pageX = -1;
	this.md_pageY = -1;

	this.mode = '.';

	this.anchor_x = -1;
	this.anchor_y = -1;
	this.anchor_X = -1;
	this.anchor_Y = -1;

	this.org_wc = -1;
	this.org_ww = -1;

	this.org_first_index = -1;

	this.box = null;
}

//------------------------------
//
//------------------------------
function ActionObject_mousedown(e) {
	var fixed_event = jQuery.event.fix(e),
		data = e.touches ? e.touches[0] : fixed_event,
		$target = jQuery(fixed_event.currentTarget || fixed_event.target),
		img_offset = ($target.is("td") ? $target : $target.closest("td")).find("img[name^='IMG-']").offset();

	this.md_imageX = data.pageX - img_offset.left;
	this.md_imageY = data.pageY - img_offset.top;
	this.md_pageX = data.pageX;
	this.md_pageY = data.pageY;
}
//------------------------------
ImageActionObject.prototype.mousedown = ActionObject_mousedown;

//------------------------------
//
//------------------------------
function ActionObject_x(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return this.md_imageX + data.pageX - this.md_pageX;
}
//------------------------------
ImageActionObject.prototype.x = ActionObject_x;

//------------------------------
//
//------------------------------
function ActionObject_y(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return this.md_imageY + data.pageY - this.md_pageY;
}
//------------------------------
ImageActionObject.prototype.y = ActionObject_y;

//------------------------------
//
//------------------------------
function ActionObject_offset_x(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return data.pageX - this.md_pageX;
}
//------------------------------
ImageActionObject.prototype.offset_x = ActionObject_offset_x;

//------------------------------
//
//------------------------------
function ActionObject_offset_y(e) {
	var data = e.touches ? e.touches[0] : jQuery.event.fix(e);

	return data.pageY - this.md_pageY;
}
//------------------------------
ImageActionObject.prototype.offset_y = ActionObject_offset_y;

//------------------------------
//
//------------------------------
function onImageMouseDown(e) {
	return onActionMouseDown(e, ImageAction);
}

//------------------------------
//
//------------------------------
function SetVarText(id, val) {
	$('#' + id).text(val);
}

//------------------------------
//
//------------------------------
function setVOIText() {
	var wc = IDS.wc;
	var ww = IDS.ww;
	if (wc == 0 && ww == 0) {
		wc = "";
		ww = "";
	}
	$('#range-l').html(wc);
	$('#range-w').html(ww);
}

//------------------------------
//
//------------------------------
function change_action(arg) {
	if (IDS.action == arg)
		return;
	IDS.action = arg;
	setActionText();
	setup_action(arg);
	ping("ACTION=" +  arg);
}

//------------------------------
//
//------------------------------
function change_overlay(arg) {
	if (IDS.overlay == arg)
		return;
	IDS.overlay = arg;
	setup_annotations(arg);
	ping("OVERLAY=" +  arg);
}

//------------------------------
//
//------------------------------
function SetupSeriesDetail() {
	var div = $('#SeriesDetail');
	div.css('left', '1px');
	div.css('top', <%=QSV.window_height%> - div.offsetHeight+'px');
	div.hide();
}

//------------------------------
//
//------------------------------
function show_series_detail() {
	var div = $('#SeriesDetail');
	div.toggle().css('bottom', '0px');
}

//----------------------------------------------------------------------------------------
</SCRIPT>
<SCRIPT LANGUAGE="JavaScript1.2">
//----------------------------------------------------------------------------------------
// Viewer related code
//----------------------------------------------------------------------------------------

<%  if (m_browser.os == "M" && m_browser.type == "IE") { %>
//------------------------------
//
//------------------------------
IR.prototype.make_measure_table = function(key) {

	//------------------------------
	//
	//------------------------------
	function select_measure_length(pixel_spacing, limit) {
		var real_len_list = new Array(1.0, 10.0, 100.0);
		var disp_len_list = new Array(0.0,  0.0,   0.0);
		for (var i = 0; i < real_len_list.length; i++) {
			var rlen = real_len_list[i];
			var dlen = rlen / pixel_spacing;
			if (dlen < 16)
				continue;
			if (dlen > limit)
				continue;
			disp_len_list[i] = dlen;
		}
		for (var i = disp_len_list.length - 1; i >= 0; i--) {
			var dlen = disp_len_list[i];
			if (dlen != 0.0)
				return dlen;
		}
		return 0;
	}

	var scale = IDS.scale;
	var ps, limit;
	switch (key) {
	case 'BC':
		ps = <%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? "this.ys" : "this.xs"%> / scale;
		limit = <%=Layout.viewWidth * 2 / 3%>;
		break;
	case 'MR':
		ps = <%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? "this.xs" : "this.ys"%> / scale;
		limit = <%=Layout.viewHeight * 2 / 3%>;
		break;
	}

	var length = select_measure_length(ps, limit);
	if (length == 0)
		return "";

	length = Math.floor(length + 0.5);

	var html;
	switch (key) {
	case 'BC':
		html = '<table style="position:absolute;height:6;top:<%=Layout.viewHeight - 14%>px;left:' + Math.floor((<%=Layout.viewWidth%> - length) / 2) + 'px;width:' + length + 'px;border-collapse:collapse;border-bottom:1px solid #FFAA00;" cellpadding="0" cellspacing="0" cols="1" rows="1">';
		break;

	case 'MR':
		html = '<table style="position:absolute;height:' + length + 'px;top:' + Math.floor((<%=Layout.viewHeight%> - length) / 2) + 'px;left:<%=Layout.viewWidth - 14%>px;border-collapse:collapse;border-right:1px solid #FFAA00;" cellpadding="0" cellspacing="0" rows="1" cols="1">';
		break;
	}

	return html + '<tr><td></td></tr></table>';

}
<%  } else { %>
//------------------------------
//
//------------------------------
IR.prototype.make_measure_table = function(key) {

	//------------------------------
	//
	//------------------------------
	function select_measure_unit(pixel_spacing, limit) {
		var real_len_list = new Array(1.0, 10.0, 100.0);
		var disp_len_list = new Array(0.0,  0.0,   0.0);
		for (var i = 0; i < real_len_list.length; i++) {
			var rlen = real_len_list[i];
			var dlen = rlen / pixel_spacing;
			if (dlen < 16)
				continue;
			if (dlen > limit)
				continue;
			disp_len_list[i] = dlen;
		}
		for (var i = 0; i < disp_len_list.length; i++) {
			var dlen = disp_len_list[i];
			if (dlen != 0.0)
				return dlen;
		}
		return 0;
	}

	var scale = IDS.scale;
	var ps, limit;
	switch (key) {
	case 'BC':
		ps = <%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? "this.ys" : "this.xs"%> / scale;
		limit = <%=Layout.viewWidth * 2 / 3%>;
		break;
	case 'MR':
		ps = <%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? "this.xs" : "this.ys"%> / scale;
		limit = <%=Layout.viewHeight * 2 / 3%>;
		break;
	}

	var unit = select_measure_unit(ps, limit);
	if (unit == 0)
		return "";

	var count = Math.floor(limit / unit);
	if (count > 10)
		count = 10;

	var size = Math.ceil(unit * count);

	var html;
	switch (key) {
	case 'BC':
		html = '<table style="position:absolute;height:6px;top:<%=Layout.viewHeight - 14%>px;left:' + Math.floor((<%=Layout.viewWidth%> - size) / 2) + 'px;width:' + size + 'px;border-collapse:collapse;border-bottom:1px solid #FFAA00;" cellpadding="0" cellspacing="0" cols="' + count + '" rows="1">';
		html += '<tr style="height:5;">';
		var last_x = 0;
		for (var i = 0; i < count; i++) {
			var x = Math.floor((i + 1) * unit + 0.5);
			var width = x - last_x - 1;
			last_x = x;
			html += '<td style="width:' + width + 'px;';
			if (i == 0)
				html += 'border-left:1px solid #FFAA00;'
			html += 'border-right:1px solid #FFAA00;"></td>';
		}
		html += '</tr>';
		break;

	case 'MR':
		html = '<table style="position:absolute;height:' + size + 'px;top:' + Math.floor((<%=Layout.viewHeight%> - size) / 2) + 'px;left:<%=Layout.viewWidth - 14%>px;border-collapse:collapse;border-right:1px solid #FFAA00;" cellpadding="0" cellspacing="0" rows="' + count + '" cols="1">';
		var last_y = 0;
		for (var i = 0; i < count; i++) {
			var y = Math.floor((i + 1) * unit + 0.5);
			var height = y - last_y;
			last_y = y;
			if (i == count - 1)
				height++;
			html += '<tr style="height:' + height + 'px;">';
			html += '<td style="width:5px;border-top:1px solid #FFAA00;';
			if (i == count - 1)
				html += 'border-bottom:1px solid #FFAA00;';
			html += '"></td>';
			html += '</tr>';
		}
		break;
	}

	return html + '</table>';

}
<%  } %>
//------------------------------
//
//------------------------------
IR.prototype.put_annotation = function(flag, index) {
	var html = "";
	if (flag == 'N') {
		var TL = '<DIV STYLE="position:absolute;top:0px;left:0px;" CLASS="ANNTEXT">';
		TL += this.number;
		TL += '<DIV>';
		html = TL;
	} else if (flag == 'D') {

		var TL = '<DIV STYLE="position:absolute;top:0px;left:0px;" CLASS="ANNTEXT">';
		TL += 'No: ' + this.number;
		var fovx = Math.floor(this.cols * this.xs * (<%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? Layout.viewHeight : Layout.viewWidth%> / (this.cols * IDS.scale)) + 0.5);
		var fovy = Math.floor(this.rows * this.ys * (<%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? Layout.viewWidth : Layout.viewHeight%> / (this.rows * IDS.scale)) + 0.5);
		if (fovx != 0 && fovy != 0)
			TL += '<BR>FOV: ' + <%=QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? "fovy + 'x' + fovx" : "fovx + 'x' + fovy"%>;
		TL += '</DIV>';

		var TR = "";
		if (this.time != 0) {
			TR = '<table style="position:absolute;top:0px;left:<%=Math.Floor(Convert.ToDouble(Layout.viewWidth / 2 + 8))%>px;width:<%=Math.Floor(Convert.ToDouble(Layout.viewWidth / 2 - 8))%>px;"><tr><td valign="top" align="right" CLASS="ANNTEXT">';
			TR += 'Tm: ' + prettyTime(this.time);
			TR +=  '</td></tr></table>';
		}

		var MR = this.make_measure_table('MR');

		var BC = this.make_measure_table('BC');

		html = TL +  TR + MR + BC;
	}
	$('#ANN-' + index).html(html);
}

//------------------------------
// ImageDisplaySetting
//------------------------------
function ImageDisplaySetting() {

	// Scale
	this.scale = <%=Layout.scale%>;
	this.fit = <%=(QSV.scale == 0 ? "true" : "false")%>;

	// Zoom
	this.zx = <%=(QSV.zx < 0 ? Math.Ceiling(Convert.ToDouble(Layout.imageWidth / 2)) : QSV.zx)%>;
	this.zy = <%=(QSV.zy < 0 ? Math.Ceiling(Convert.ToDouble(Layout.imageHeight / 2)) : QSV.zy)%>;

	// VOI
	this.wc = <%=VOITable.wc%>;
	this.ww = <%=VOITable.ww%>;

	// mode
	this.overlay = '<%=QSV.overlay%>';
	this.action = '<%=QSV.action%>';

	// Client side IP
	this.clientip = '<%=QSV.clientip%>';
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.query_string = function() {
	return '&VOI=' + escape('' + this.wc + ',' + this.ww)
	     + (this.fit ? '' : '&SCALE=' + this.scale + '&ZX=' + this.zx + '&ZY=' + this.zy)
	     + '&ACTION=' + escape(this.action)
	     + '&OVERLAY=' + escape(IDS.overlay)
	     + (this.clientip == "R0M0" ? "" : '&CLIENTIP=' + this.clientip);
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.image_src = function(index, nocache) {
	return IL[0].uri()
		+ '?WC=' + this.wc
		+ '&WW=' + this.ww
	    + '&HEIGHT=<%=(QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? Layout.viewWidth : Layout.viewHeight)%>'
	    + '&WIDTH=<%=(QSV.clientip[1] == '1' || QSV.clientip[1] == '3' ? Layout.viewHeight : Layout.viewWidth)%>'
	    + (this.fit ? '' : '&SCALE=' + this.scale
<% if (QSV.clientip == "R1M0") { %>
	      + '&ZX=' + this.zy + '&ZY=' + (<%=Layout.imageWidth%> - this.zx)
<% } else if (QSV.clientip == "R2M0") { %>
	      + '&ZX=' + (<%=Layout.imageWidth%> - this.zx) + '&ZY=' + (<%=Layout.imageHeight%> - this.zy)
<% } else if (QSV.clientip == "R3M0") { %>
	      + '&ZX=' + (<%=Layout.imageHeight%> - this.zy) + '&ZY=' + this.zx
<% } else if (QSV.clientip == "R0M1") { %>
	      + '&ZX=' + (<%=Layout.imageWidth%> - this.zx) + '&ZY=' + this.zy
<% } else if (QSV.clientip == "R1M1") { %>
	      + '&ZX=' + this.zy + '&ZY=' + this.zx
<% } else if (QSV.clientip == "R2M1") { %>
	      + '&ZX=' + this.zx + '&ZY=' + (<%=Layout.imageHeight%> - this.zy)
<% } else if (QSV.clientip == "R3M1") { %>
	      + '&ZX=' + (<%=Layout.imageWidth%> - this.zy) + '&ZY=' + (<%=Layout.imageHeight%> - this.zy)
<% } else { %>
	      + '&ZX=' + this.zx + '&ZY=' + this.zy
<% } %>
	      )
		+ (nocache ? '&CACHE=2' : '');

}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_zoom_center = function(x, y, anchor_x, anchor_y, anchor_X, anchor_Y) {
<%/*
	X2: }EX|CgIWiW
	x2: }EX|Cg\W
	C2: \S|CgIWiW
	c2: \SW

	X1: O}EX|CgIWiW
	x1: O}EX|Cg\W
	C1: O\S|CgIWiW
	c1: O\SW

	S: XP[

	X2 = X1 = X
	c2 = c1 = c

	(X2 - C2) * S = x2 - c2
	(X2 - C1) * S = x1 - c2

	(X - C2) * S = x2 - c
	(X - C1) * S = x1 - c

	C2 = (x1 - x2)/S + C1

*/%>
	var S = this.scale;

	this.zx = Math.floor((anchor_x - x)/S + anchor_X);
	this.zy = Math.floor((anchor_y - y)/S + anchor_Y);

	this.adjust_zoom_center();
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_zoom_center2 = function(x, y, newScale) {
<%/*
	X2: Y[}EX|CgIWiW
	x2: Y[}EX|Cg\W
	C2: Y[\S|CgIWiW
	c2: Y[\SW
	S2: Y[XP[

	X1: Y[O}EX|CgIWiW
	x1: Y[O}EX|Cg\W
	C1: Y[O\S|CgIWiW
	c1: Y[O\SW
	S1: Y[OXP[


	(X1 - C1) * S1 = (x1 - c1)
	(X2 - C2) * S2 = (x2 - c2)

	c1 = c2 = c
	x1 = x2 = x
	X1 = X2 = X

	(X - C1) * S1 = x - c
	(X - C2) * S2 = x - c

	X = (x - c) / S1 + C1
	  = (x - c) / S2 + C2

	C2 = C1 + (x - c)/S1 - (x - c)/S2
*/%>
	var cx = <%=Layout.viewWidth%> / 2;
	var cy = <%=Layout.viewHeight%> / 2;
	var Cx = <%=Layout.imageWidth%> / 2;
	var Cy = <%=Layout.imageHeight%> / 2;
	var S1 = this.scale;
	var S2 = newScale;

	this.zx = Math.floor(Cx + (x - cx)/S1 - (x - cx)/S2);
	this.zy = Math.floor(Cy + (y - cy)/S1 - (y - cy)/S2);

	this.scale = newScale;

	this.adjust_zoom_center();
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.adjust_zoom_center = function() {
	var scale = this.scale;

	var halfX = Math.floor(<%=Layout.viewWidth%> / scale / 2);
	var halfY = Math.floor(<%=Layout.viewHeight%> / scale / 2);

	if (this.zx < halfX)
		this.zx = halfX;
	else if (this.zx > <%=Layout.imageWidth%> - halfX)
		this.zx = <%=Layout.imageWidth%> - halfX;

	if (this.zy < halfY)
		this.zy = halfY;
	else if (this.zy > <%=Layout.imageHeight%> - halfY)
		this.zy = <%=Layout.imageHeight%> - halfY;
}

//------------------------------
//
//------------------------------
ImageDisplaySetting.prototype.set_drag_voi = function(orgWC, orgWW, x, y) {
<%/*
	sF
	}EXlgB
	AWC  WW itjgB
	AsB

	ASsBB
	AIsBXDAYsitj
	Is`^BpxROx

	WC vZF
	}EX 256  WW A
	Y = a * x^2  --- (ww / 2) = a * (256 * 256) --- a = ww / (256 * 256 * 2)

	WW vZF
	}EX E256  WW {iRgXgj
	Y = 2^X

*/%>
	var ax = Math.abs(x);
	if (ax <= 4)
		ax = 0;
	else
		ax -= 4;
	x = x < 0 ? -ax : ax;

	var ay = Math.abs(y);
	if (ay <= 4)
		ay = 0;
	else
		ay -= 4;
	y = y < 0 ? ay : -ay;

	if (ax == 0 && ay == 0)
		return;

	var tan30 = 0.57735;
	if (ax != 0 && ay / ax < tan30) {
		this.ww = Math.floor(orgWW * Math.pow(2, x / 256));
	} else if (ay != 0 && ax / ay < tan30) {
		this.wc = orgWC + Math.floor(ay * y * orgWW / 0x20000);
	} else {
		this.ww = Math.floor(orgWW * Math.pow(2, x / 256));
		this.wc = orgWC + Math.floor(ay * y * orgWW / 0x20000);
	}
}

//------------------------------
//
//------------------------------
ImageActionObject.prototype.begin_drag = function(e) {

	var div = $(e.currentTarget || e.srcElement);
	this.box = (div.is("img") && div[0] || div.find("img[name^='IMG-']")[0] || $("#IMG-0")[0]).box;

	this.box.start_track_update();

	if (this.mode == 'Z') {
		var x = this.x(e);
		var y = this.y(e);
		if (IDS.fit) {
			IDS.set_zoom_center2(x, y, <%=Layout.zoom_scale%>);
			IDS.fit = false;
			this.box.track_update(true);
			setScaleText();
			reload_annotation_text();
		}
		this.anchor_x = x;
		this.anchor_y = y;
		this.anchor_X = IDS.zx;
		this.anchor_Y = IDS.zy;
	} else if (this.mode == 'V') {
		this.org_wc = IDS.wc;
		this.org_ww = IDS.ww;
	}
}

//------------------------------
//
//------------------------------
function eventIsTouch(e) {
	return e.touches ? true : false;
}

//------------------------------
//
//------------------------------
ImageActionObject.prototype.do_drag = function(e) {
	if (this.mode == 'Z') {
		var x = IDS.zx;
		var y = IDS.zy;
		IDS.set_zoom_center(this.x(e), this.y(e), this.anchor_x, this.anchor_y, this.anchor_X, this.anchor_Y);
		if (IDS.zx != x || IDS.zy != y)
			this.box.track_update(true);
	} else if (this.mode == 'V') {
		var wc = IDS.wc;
		var ww = IDS.ww;
		var ox = this.offset_x(e);
		var oy = this.offset_y(e);
		if (eventIsTouch(e))
		{
			ox = ox * <%=VOITable.wc%> / window.screen.width;
			oy = oy * <%=VOITable.ww%> / window.screen.height;
		}
		IDS.set_drag_voi(this.org_wc, this.org_ww, ox, oy);
		if (IDS.wc != wc || IDS.ww != ww) {
			this.box.track_update(true);
			setVOIText();
		}
	}
}

//------------------------------
//
//------------------------------

function iao_pagexy_available(e)
{
	return !eventIsTouch(e) || e.touches.length > 0;
}

ImageActionObject.prototype.end_drag = function(e) {
	if (this.mode == 'Z') {
		if (iao_pagexy_available(e)) {
			IDS.set_zoom_center(this.x(e), this.y(e), this.anchor_x, this.anchor_y, this.anchor_X, this.anchor_Y);
		}
<% if (Layout.full) { %>
		reload_imgbox(ImageBoxTable);
<% } else { %>
		Reload();
<% } %>
	} else if (this.mode == 'V') {
		if (iao_pagexy_available(e)) {
			var ox = this.offset_x(e);
			var oy = this.offset_y(e);
			if (eventIsTouch(e))
			{
				ox = ox * <%=VOITable.wc%> / window.screen.width;
				oy = oy * <%=VOITable.ww%> / window.screen.height;
			}
			IDS.set_drag_voi(this.org_wc, this.org_ww, ox, oy);
		}
		reload_imgbox(ImageBoxTable);
		setVOIText();
	}

	this.box.end_track_update();
}

//------------------------------
//
//------------------------------
function reload_imgbox(table) {
	var box = table[0];
	box.reload();
}

//------------------------------
//
//------------------------------
function set_imagefilter(img, clientip) {
	var r = clientip.charAt(1);
	var m = clientip.charAt(3);
	img.style.filter = "progid:DXImageTransform.Microsoft.BasicImage(Rotation = " + r + ", Mirror = " + m + ")";
}

//------------------------------
//
//------------------------------
function setup_imgboxes() {
	for (var i = 0; i < document.images.length; i++) {
		var img = document.images[i];
		var name = img.name;
		if (name.indexOf('IMG-') == 0) {
			var index = name.substring(4);
			var box = new ImageBox(img, parseInt(index));
			ImageBoxTable[index] = box;
			img.box = box;

			<% if (m_browser.type == "IE" && m_browser.version >= 5.5 && m_browser.version < 10) { %>
			set_imagefilter(img, IDS.clientip);
			<% } %>
		}
	}
	$('#ACT-' + index).box = box;
}

//------------------------------
//
//------------------------------
function set_annotation1(flag, index) {
	var id = '#' + 'ANN-' + index;
	if (flag == '.') {
		$(id).hide();
	} else {
		var img = IL[0];
		img.put_annotation(flag, 0);
		$(id).show();
	}
}

//------------------------------
//
//------------------------------
function setup_annotations(flag) {
	set_annotation1(flag, 0);
}

//------------------------------
//
//------------------------------
function reload_annotation_text() {
	setup_annotations(IDS.overlay);
}

//------------------------------
//
//------------------------------
function setup_action(flag) {
	jQuery("#ACT-0").hide();
	var div = jQuery("#IMG-0").closest("td")[0];

	if (div) {
		$(div)
			.unbind('mousedown')
			.unbind('touchstart');
		if (flag == '.') {
			div.style.visibility = 'hidden';
		} else {
			div.style.visibility = 'visible';
			$(div)
				.bind('mousedown', onImageMouseDown)
				.bind('touchstart', onImageMouseDown);
		}
	}
	ImageAction.mode = flag;
}

//------------------------------
//
//------------------------------
function Reload() {
	location.href = ('xp-study-viewer.aspx'
	               + '?VOLUME=<%=QSV.volume%>'
	               + '&PATH=<%=QSV.path%>'
	               + '&IMAGE=<%=QSV.image_path%>'
	               + '&WW=' + <%=window_width()%>
	               + '&WH=' + <%=window_height()%>
	               + IDS.query_string());
}

//------------------------------
//
//------------------------------
function setActionText() {
	var str;
	switch (IDS.action) {
	case 'Z':
		if (IDS.fit)
			str = 'Zoom';
		else
			str = 'Pan';
		break;
	case 'V':
		str = 'W/L';
		break;
	case 'P':
		str = 'Page';
		break;
	default:
		str = '';
		break;
	}
	$("#action option[value='"+IDS.action+"']").attr('selected', 'selected');
	//$('#action-label').text(str);
}
//------------------------------
//
//------------------------------
function setScaleText() {
	//$('#scale-label').text(Math.floor(IDS.scale * 100) + '%');
	setActionText();
}

//------------------------------
//
//------------------------------
function onImageLoad(e) {
	e = e || window.event;
	var box = (e.currentTarget || e.target || e.srcElement).box;

	if (box != null)
		box.loaded = true;
}

//------------------------------
//
//------------------------------
function onFirstLoad() {

	setup_imgboxes();

	setVOIText();
	setScaleText();

	<% if (m_browser.type == "IE" && m_browser.version >= 5.5 && m_browser.version < 10) { %>
	SetClientIPText();
	<% } %>

	reload_imgbox(ImageBoxTable);
	reload_annotation_text();

	setup_action(IDS.action);

	SetupSeriesDetail();

	pingImage = document.images['ping'];

	window.onload = new Function("return false;");

	return false;
}

//------------------------------
//
//------------------------------
function scale_changed(arg) {
	arg = parseFloat(arg);
	if (arg == 0) {
		if (IDS.fit)
			return;
		IDS.fit = true;
		IDS.scale = <%=Layout.fit_scale%>;
	} else {
		if (IDS.scale == arg)
			return;
		IDS.fit = false;
		IDS.scale = arg;
	}

	Reload();
}

//------------------------------
//
//------------------------------
function client_ip(arg) {
	if (IDS.clientip == arg)
		return;
	var old = IDS.clientip;
	IDS.clientip = arg;

	if (IDS.fit) {
		var o = old.charAt(1) == '1' || old.charAt(1) == '3' ? 1 : 0;
		var a = arg.charAt(1) == '1' || arg.charAt(1) == '3' ? 1 : 0;
		if (o + a == 1) {
			Reload();
		} else {
			var img = ImageBoxTable[0].img;
			set_imagefilter(img, arg);
			reload_annotation_text();
			SetClientIPText(arg);
			ping("_CLIENTIP=" + arg);
		}
	} else {
		IDS.fit = true;
		IDS.scale = <%=Layout.fit_scale%>;
		Reload();
	}

}

//------------------------------
//
//------------------------------
function SetClientIPText() {

	/*if (IDS.clientip == "R1M0")
		SetVarText("client-label", "TurnRight");
	else if (IDS.clientip == "R3M0")
		SetVarText("client-label", "TurnLeft");
	else if (IDS.clientip == "R2M0")
		SetVarText("client-label", "Invert");
	else if (IDS.clientip == "R0M1")
		SetVarText("client-label", "Mirror");
	else if (IDS.clientip == "R1M1")
		SetVarText("client-label", "Mirror+TurnLeft");
	else if (IDS.clientip == "R3M1")
		SetVarText("client-label", "Mirror+TurnRight");
	else if (IDS.clientip == "R2M1")
		SetVarText("client-label", "Mirror+Invert")
	else
		SetVarText("client-label", "Normal");*/
}
//------------------------------
//
//------------------------------
function preset_voi(arg) {
	if ( !arg ) return;
	var cw = arg.split(',');

	var wc = parseInt(cw[0]);
	var ww = parseInt(cw[1]);

	if (wc == -1 && ww == -1) {
		var str = prompt('Insert Desired Window Level / Window Width', IDS.wc + ' / ' + IDS.ww);
		if (str == null || str.length == 0)
			return;
		var ary = str.match(/\s*(-?\d+)\s*\/\s*(\d+)\s*/);
		if (ary != null) {
			wc = parseInt(ary[1]);
			ww = parseInt(ary[2]);
		} else {
			ary = str.match(/\s*\/\s*(\d+)\s*/);
			if (ary != null) {
				wc = IDS.wc;
				ww = parseInt(ary[1]);
			} else {
				ary = str.match(/\s*(-?\d+)\s*/);
				if (ary != null) {
					wc = parseInt(ary[1]);
					ww = IDS.ww;
				} else {
					alert('Invalid Window Level/Window Width Entry');
					return;
				}
			}
		}
	}

	if (IDS.wc == wc && IDS.ww == ww)
		return;

	IDS.wc = wc;
	IDS.ww = ww;

	setVOIText(wc, ww);

	reload_imgbox(ImageBoxTable);
}

//------------------------------
//
//------------------------------
function ping(arg) {
	if (pingImage)
		pingImage.src = "media/images/reload.png";
}

//------------------------------
//
//------------------------------
<%printImageList(ImageList, ImageSpace);%>
var IDS = new ImageDisplaySetting();
var ImageBoxTable = new Array;
var ImageAction = new ImageActionObject();
var CurrentAction = null;
var pingImage = null;

//----------------------------------------------------------------------------------------
</SCRIPT>
<STYLE TYPE="text/css">
/****************************************************************************************/

BODY {
	background-color: #040a18;
	color:white;
	font-size:10pt;

	border-width: 0 0 0 0;
<% if (m_browser.type == "NN" && m_browser.os == "M") { %>
	margin-left:-6;
	margin-top:-6;
	margin-right:0;
	margin-bottom:0;
<% } else { %>
	margin: 0 0 0 0;
<% } %>
	padding: 0 0 0 0;
}

SPAN.label {
	color:#E0E0C0;
}

NOBR.STUDY_INFO {
	font-family: monospace;
	font-size: 9pt;
}

SPAN.DIRTEXT {
	font-size:9pt;
}

TD.BAR {
	background-color:#405050; /* #687686 */
	margin:0 0 0 0;
	padding:0 0 0 0;
}

TD.STRIP {
	background-color: black;
	margin:0 0 0 0;
	padding:0 0 0 0;
}

TD.CANVAS {
	background-color: #102020;
	margin:0 0 0 0;
	padding:0 0 0 0;
}

DIV.ANN {
	position:absolute;
	height:<%=Layout.viewHeight%>px;
	width:<%=Layout.viewWidth%>px;
	margin:0 0 0 0;
	padding:0 0 0 0;
	z-index:1;
}
DIV.ACT {
	position:absolute;
	height:<%=Layout.viewHeight%>px;
	width:<%=Layout.viewWidth%>px;
	margin:0 0 0 0;
	padding:0 0 0 0;
	visibility: hidden;
	z-index:2;
	background-color:white;
	opacity: 0;
	filter: alpha(opacity = 0);
}

.ANNTEXT {
	font-size:9pt;
	color:#FFAA00;
}

NOBR.BarText {
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
}

TD.MenuButton {
	color: white;
	font-weight: bold;
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
	background-color: #687686;
	padding: 0 7 0 7;
	margin: 0 0 0 0;
}

TD.VarText {
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
	background-color: #304040;
	padding: 0 0 0 2;
	margin: 0 0 0 0;
}

A.DrMenu-item {
	color: white;
	font-weight: bold;
	text-decoration: none;
}

A:hover {
	color:#FFAA00;
}

LAYER.DrMenu-list {
	color: white;
	background-color: #687686;
	border-width: 1 2 2 1;
	border-style: solid;
	border-color: #FFAA00;
	padding: 4 8 2 8;
	margin: 0 0 0 0;
}
DIV.DrMenu-list {
	position: absolute;
	z-index: 4;
 	display:none;
	color: white;
	background-color: #687686;
	border-width: 1 2 2 1;
	border-style: solid;
	border-color: #FFAA00;
	padding: 4 8 2 8;
	margin: 0 0 0 0;
}
NOBR.DrMenu-listItem {
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
}

.SeriesDetail {
	position: absolute;
	left: 0;
	z-index:4;
	width: <%=(QSV.window_width - kStripWidth - 2)%>;
	display:none;
	background-color:#405050;
	border-width: 1;
	border-style: solid;
	border-color: #FFAA00;
	padding: 4 8 2 8;
	margin: 0 0 0 0;
	font-family:Lucida;
	font-size: <%=(m_browser.os == "M" && m_browser.type == "NN" ? 12 : 10)%>pt;
	color:#E0E0C0;
}
.for_select {
    padding: 3px 7px 7px 7px;
    margin-left: -3px;
    position: inherit;
}
</STYLE>
<!--[if lte IE 7]>
    <script type="text/javascript">
        $(document).ready(function(){
            var w = 0;
            $(".control-bar>.filter-group").each(function(i,obj){
                w += $(obj).width();
            });

            w = ($(".control-bar").width() - w - 30)/2;
            if (w<25) w=25;
            $($(".control-bar>.filter-group").eq(0)).css("margin-left",w+"px");
        });
    </script>
    <style type="text/css">
        DIV.ANN {
            position: inherit;
        }
        .control-bar div.filter-group {
            float: left;
        }

    </style>
<![endif]-->
</Head>
<BODY>
<div class="control-bar">
			<div class="filter-group first_one">
				<select id="overlay" class="chzn-select blue" style="width:120px;display:none">
					<optgroup label="Overlay">
					<option value="N" <%= QSV.overlay == "N" ? "selected='selected'" : "" %>>Number</option>
					<option value="D" <%= QSV.overlay == "D" ? "selected='selected'" : "" %>>Detail</option>
					<option value="." <%= QSV.overlay == "." ? "selected='selected'" : "" %>>None</option>
					</optgroup>
				</select>
				<label ></label>
			</div>
			<div class="filter-group">
				<select id="action" class="chzn-select blue" style="width:98px;display:none">
					<optgroup label="Action">
					<option value="Z" <%= QSV.action == "Z" ? "selected='selected'" : "" %>>Zoom/Pan</option>
					<% if (((ImageObject)ImageList[0]).bits != 8) { %>
					<option value="V" <%= QSV.action == "V" ? "selected='selected'" : "" %>>W/L</option>
					<% } %>
					<option value="." <%= QSV.action == "." ? "selected='selected'" : "" %>>None</option>
					</optgroup>
				</select>
				<!--label id="action-label" class="for_select" style="margin-left:0px">Zoom</label-->
			</div>
			<div class="filter-group">
			<select id="range" class="chzn-select blue" style="width:120px;display:none">
				<optgroup label="Range">
				<%
					foreach (VOIEntry voi in VOITable.table) {
						Response.Write("<option value='" + voi.wc.ToString() + "," + voi.ww.ToString()+"'>"+voi.label+"</option>");
					}
				%>
				</optgroup>
			</select>
			<label class="for_select"style="margin-left:0px">L: <span id="range-l">2089</span> &nbsp;&nbsp; W: <span id="range-w">4569</span></label>
			</div>
			<div class="filter-group">
				<select id="scale" class="chzn-select blue" style="width:100px;display:none">
					<optgroup label="Scale">
			<%
				ArrayList table = new ArrayList();
				for (Double scale = 2; scale > Layout.fit_scale; scale /= 2)
					table.Add(String.Format("<option value='{0}' {2}>{1}</option>",  scale.ToString(), (scale * 100).ToString() + "%", (scale == QSV.scale?"selected='selected'":"")));
				table.Add(String.Format("<option value='{0}' {2}>{1}</option>", "0", "Fit (" + (Layout.fit_scale * 100).ToString() + "%)", (Layout.fit_scale == QSV.scale?"selected='selected'":"")));
				table.Reverse();
				foreach(object item in table) {
					Response.Write(item);
				}
			%>
				</optgroup>
				</select>
				<!--label id="scale-label" class="for_select">26%</label-->
			</div>
<% if (m_browser.type == "IE" && m_browser.version >= 5.5 && m_browser.version < 10) { %>
			<div class="filter-group">
				<select id="client" class="chzn-select blue" style="width:114px;display:none">
					<optgroup label="View">
					<option value="R0M0" <%=QSV.clientip=="R0M0"?"selected=selected":""%> >Normal</option>
					<option value="R1M0" <%=QSV.clientip=="R1M0"?"selected=selected":""%> >TurnRight</option>
					<option value="R3M0" <%=QSV.clientip=="R3M0"?"selected=selected":""%> >TurnLeft</option>
					<option value="R2M0" <%=QSV.clientip=="R2M0"?"selected=selected":""%> >Invert</option>
					<option value="R0M1" <%=QSV.clientip=="R0M1"?"selected=selected":""%> >Mirror</option>
					<option value="R3M1" <%=QSV.clientip=="R3M1"?"selected=selected":""%> >Mirror+TurnRight</option>
					<option value="R1M1" <%=QSV.clientip=="R1M1"?"selected=selected":""%> >Mirror+TurnLeft</option>
					<option value="R2M1" <%=QSV.clientip=="R2M1"?"selected=selected":""%> >Mirror+Invert</option>
					</optgroup>
				</select>
				<!--label id="client-label" class="for_select">Normal</label-->
			</div>

<% } %>
    <div class="clear"></div>
	</div>
	<div class="x-ray">
		<div class="caption" STYLE="width:<%=QSV.window_width%>;height:<%=kInfoBarHeight%>">
			<span style="overflow: hidden; display: inline-block; max-width: <%=QSV.window_width-50%>px"><%print_study_info(DOM);%><%=" "%><%print_study_info_ex(DOM);%><%=" "%></span>
			<span style="overflow: hidden; display: inline-block"><A STYLE='color:white;' HREF='javascript:show_series_detail()'>Info</A></span>
		</div>
		<div>
            <TABLE ALIGN="LEFT" HSPACE="0" VSPACE="0" CELLPADDING="0" CELLSPACING="0" BORDER="0" BGCOLOR="BLACK" WIDTH="<%=QSV.window_width%>" HEIGHT="<%=QSV.window_height - kInfoBarHeight - kMenuBarHeight -38 %>">
<TR STYLE="height:<%=QSV.window_height - kInfoBarHeight - kMenuBarHeight%>">
<!-- CANVAS area begin -->
<TD STYLE="width:<%=QSV.window_width - kStripWidth%>;" NOWRAP ALIGN="LEFT" VALIGN="TOP" CLASS="CANVAS"><%printImageTable(Layout);%></TD>
<!-- CANVAS area end -->
<!-- STRIP area begin -->
<TD STYLE="width:<%=kStripWidth%>;" NOWRAP ALIGN="LEFT" VALIGN="TOP" CLASS="STRIP"><TABLE HEIGHT="<%=QSV.window_height - kInfoBarHeight - kMenuBarHeight%>" WIDTH="<%=kStripWidth%>" ALIGN="TOP" HSPACE="0" VSPACE="0" CELLPADDING="0" CELLSPACING="0" BORDER="0">
<TR>
	<TD><IMG SRC="/DIOWave/grayscale.gif" HEIGHT="<%=QSV.window_height - kInfoBarHeight - kMenuBarHeight%>" WIDTH="<%=kStripWidth%>" BORDER="0" HSPACE="0" VSPACE="0"></TD>
</TR>
</TABLE></TD>
<!-- STRIP area end -->
</TR>
</TABLE>
<% printSeriesDetail(DOM, QSV); %>
<div style="clear:both"></div>
</div>
	<%

	UInt32 left = (UInt32)Math.Floor(Convert.ToDouble((Layout.canvasWidth - Layout.viewWidth)) / 2);
	UInt32 top = kInfoBarHeight + kMenuBarHeight + (UInt32)Math.Floor(Convert.ToDouble((Layout.canvasHeight - Layout.viewHeight)) / 2);
	//Writer.Write("<DIV ID='ANN-0' CLASS='ANN' STYLE='top:" + top + "px;left:" + left + "px;'></DIV>\n");
	Writer.Write("<DIV ID='ACT-0' CLASS='ACT' STYLE='top:" + top + "px;left:" + left + "px;'></DIV>\n");
%>

<style type="text/css">
    .control-bar .filter-group.first_one {margin-left: 25px;}
</style>
<DIV STYLE="position:absolute;top:7px;left:20px;z-index:1300"><A HREF="javascript:parent.reload_viewer()"><IMG width="16" NAME="ping" SRC="media/images/reload.png" BORDER="0" HSPACE="0" VSPACE="0"></A></DIV>
</div>
</BODY>
</HTML>
